/*
 * mousetst.h
 * 
 * Module for mouse test utility
 *
 * Copyright (c) 1988-1989, Microsoft Corporation.  All rights reserved.
 *
 *
 *		Disclaimer:	This code is example code only,
 *				and does not warranty any product
 *				as being Microsoft compatible.
 *				Microsoft will not be held responsible
 *				for claims made pertaining to this software.
 *
 */

/* I N C L U D E S */

#include <stdio.h>
#include <dos.h>
#include <stdlib.h>
#include <string.h>
#include <malloc.h>
#include <conio.h>
#include "cmfunc.h"

/* E Q U A T E S */

#define		FALSE		0
#define		TRUE		1
#define		SAVE		0
#define		RESTORE		1
#define		LEFT		1	/* Left button is pressed */
#define		RIGHT		2	/* Right button is pressed */
#define		BOTH		3	/* Both buttons are pressed */
#define		TEXT		FALSE
#define		GRAPHICS	TRUE

#define		INDIVIDUAL	0
#define		EGA		1
#define		CGA		2
#define		MCGA		3
#define		VGA		4
#define		MONO		5
#define		ATT		6
#define		TOSH		7

#define		ESC		0x1b

#define		SpecialMode0	0x20	/* Because 0 is for disable function */

/* E X T E R N A L S */

extern int fUserSub, cursorLevel, videoMode;

/* F U N C T I O N   D E F I N I T I O N S */

#if	(defined(M_I86MM) || defined(M_I86LM))
extern void far Function12(void);
extern void far Function12Info(unsigned *, unsigned *, int *, int *, int *, int *);
extern int far ReadLightPenPosition(int *, int *, int *, int *);
extern int far getchnowait(void);
extern void far ClearKB(void);
extern void far PrintString (int *, int *);
#else	/* ! (defined(M_I86MM) || defined(M_I86LM)) */
extern void Function12(void);	/* Actually, far */
extern void Function12Info(unsigned *, unsigned *, int *, int *, int *, int *);
extern int ReadLightPenPosition(int *, int *, int *, int *);
extern int getchnowait(void);
extern void ClearKB(void);
extern void PrintString (int *, int *);
#endif	/* ! (defined(M_I86MM) || defined(M_I86LM)) */

void main(void);
void IndividualTest(void);
void EGATest(void);
void CGATest(void);
void MCGATest(void);
void VGATest(void);
void MONOTest(void);
void ATTTest(void);
void TOSHTest(void);
void ScreenPixel(void);
void GMouse(void);
void MInput(int *, int *, int *);
void SetCursor(unsigned, unsigned);
void cls(void);
void BlankLine(void);
void BlankMenu(void);
void Cleanup(void);
void CFunction12(void);
void SetVideoMode(unsigned);
void VideoModeSaveRestore(unsigned);
void Pause(int);
void ShowLogo(void);
void SaveAndRestoreMouseDriverState(void);
void MouseTest(int, int, int);
void FunctionSelect(void);
void Menu2(void);
void Menu3(void);
void Menu4(void);
void Menu5(void);
